<!--
  - Pfarrplaner
  -
  - @package Pfarrplaner
  - @author Christoph Fischer <chris@toph.de>
  - @copyright (c) Christoph Fischer, https://christoph-fischer.org
  - @license https://www.gnu.org/licenses/gpl-3.0.txt GPL 3.0 or later
  - @link https://codeberg.org/pfarr.tools/pfarrplaner
  - @version git: $Id$
  -
  - Sponsored by: Evangelischer Kirchenbezirk Balingen, https://www.kirchenbezirk-balingen.de
  -
  - Pfarrplaner is based on the Laravel framework (https://laravel.com).
  - This file may contain code created by Laravel's scaffolding functions.
  -
  - This program is free software: you can redistribute it and/or modify
  - it under the terms of the GNU General Public License as published by
  - the Free Software Foundation, either version 3 of the License, or
  - (at your option) any later version.
  -
  - This program is distributed in the hope that it will be useful,
  - but WITHOUT ANY WARRANTY; without even the implied warranty of
  - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  - GNU General Public License for more details.
  -
  - You should have received a copy of the GNU General Public License
  - along with this program.  If not, see <http://www.gnu.org/licenses/>.
  -->

<template>
    <admin-layout title="Lieder">
        <template v-slot:navbar-left>
            <nav-button type="success" icon="mdi mdi-plus" title="Lied hinzufügen"
                        :href="route('song.create')">Neues Lied</nav-button>
        </template>
            <dataset
                 v-slot="{ ds }"
                 :ds-data="mySongs"
                 ds-sort-by="title"
                 :ds-search-in="['title']"
                 :ds-search-as="{
                     title: searchFullTitle,
                 }">
            <div class="row mb-3" :data-page-count="ds.dsPagecount">
                <div class="col-md-6 mb-2 mb-md-0">
                    <dataset-search ds-search-placeholder="Suchen..." ref="search" autofocus />
                </div>
                <div class="col-md-5 text-end">
                    <dataset-show class="float-right" />
                </div>
            </div>
            <div class="row">
                <div class="col-md-12">
                    <div class="table-responsive">
                        <table class="table table-striped table-hover d-md-table">
                            <thead>
                            <tr>
                                <th>Referenz</th>
                                <th>Titel</th>
                                <th></th>
                            </tr>
                            </thead>
                            <dataset-item tag="tbody">
                                <template #default="{ row, rowIndex }">
                                    <tr>
                                        <td class="text-small">
                                            <div v-for="songbook in (row.songbooks || [])"
                                                 :title="songbook.name+(songbook.pivot.reference ? ', Nr. '+songbook.pivot.reference : '')">
                                                <img v-if="songbook.image" style="max-height: 1em;" :src="route('image', songbook.image.replace('attachments/', ''))" />
                                                {{ songbook.code }} {{ songbook.pivot.reference}} <span v-if="row.alt_eg">(EG {{ row.alt_eg}})</span>
                                            </div>

                                        </td>
                                        <td>{{ row.title }}</td>
                                        <td class="text-end">
                                            <nav-button class="btn-sm"
                                                        type="light" icon="mdi mdi-music-note-eighth" title="Noten bearbeiten"
                                                        force-icon force-no-text :href="route('liturgy.song.musiceditor', row.id)" />
                                            <nav-button class="btn-sm"
                                                        type="primary" icon="mdi mdi-pencil" title="Lied bearbeiten"
                                                        force-icon force-no-text :href="route('song.edit', row.id)" />
                                            <nav-button class="btn-sm"
                                                        type="danger" icon="mdi mdi-delete" title="Lied löschen"
                                                        force-icon force-no-text @click="deleteSong(row)" />
                                        </td>
                                    </tr>
                                </template>
                            </dataset-item>
                        </table>
                    </div>
                </div>
            </div>
            <div class="d-flex flex-md-row flex-column justify-content-between align-items-center border-top pt-2">
                <dataset-info class="mb-2 mb-md-0"/>
                <dataset-pager/>
            </div>
        </dataset>
    </admin-layout>
</template>

<script>

import {Dataset, DatasetItem, DatasetSearch,} from 'vue-dataset';
import DatasetInfo from "../../../components/Ui/dataset/DatasetInfo";
import DatasetShow from "../../../components/Ui/dataset/DatasetShow";
import DatasetPager from "../../../components/Ui/dataset/DatasetPager";
import NavButton from "../../../components/Ui/buttons/NavButton";


export default {
    name: "Index",
    props: ['songs'],
    data() {
        return {
            mySongs: this.songs,
        }
    },
    components: {
        NavButton,
        Dataset,
        DatasetItem,
        DatasetInfo,
        DatasetPager,
        DatasetSearch,
        DatasetShow
    },
    methods: {
        deleteSong(song) {
            if (!confirm('Willst du wirklich das komplette Lied löschen?')) return;
            this.$inertia.delete(route('song.destroy', song.id));
        },
        searchFullTitle(value, searchString, rowData) {
            let found = false;
            rowData.songbooks.forEach(songbook => {
                if (String(songbook.code+' '+songbook.pivot.reference+' '+rowData.title)
                    .trim().toLowerCase().includes(searchString.toLowerCase())) found = true;
            })
            return found;
        },
    }
}
</script>

<style scoped>

</style>
